#include <limits.h>


/* Return values of functions. */
#define FAILURE				1
#define SUCCESS				0

/* Flags that control the program options that have been selected. */
#define OPTION_TEST_MODE		0x00000001
#define OPTION_DETAILS_QUITE		0x00000002
#define OPTION_DETAILS_NORMAL		0x00000004
#define OPTION_DETAILS_VERBOSE		0x00000008
#define OPTION_SHOW_HEADERS		0x00000010
#define OPTION_DETAILS_CLEAR		0xFFFFFFF1

/* Lengths of strings to save account settings. */
#define SERVER_MAX			128
#define USERNAME_MAX			64
#define PASSWORD_MAX			32

/* Lengths of strings that comprise the HEADER of a filter. */
#define FIELD_NAME_MAX			64
#define FIELD_BODY_MAX			512

/* Size of buffer that holds the results of the searching and matching
   of filters. */
#define SEARCH_RESULTS_MAX		512

/* Every how many filter entries found in the configuration file will
   be space in memory will be allocated. */
#define FILTER_ENTRIES_MAX		8

#define min(A, B)			((A) < (B) ? (A) : (B))


/* Account settings. */
typedef struct {
    char server[SERVER_MAX];	/* Hostname of mail server. */
    unsigned short int port;	/* Port to connect. */
    char username[USERNAME_MAX];
    char password[PASSWORD_MAX];
    char logfile[PATH_MAX];
} account_data;

/* A header filter entry. */
typedef struct {
    char name[FIELD_NAME_MAX];	/* Header field name. */
    int explicit;		/* If field name one of FROM, TO, CC, BCC,
				   SUBJECT then zero. */
    char body[FIELD_BODY_MAX];	/* Header field body. */
} filter_entry;


void apply_filters(void);
void usage(void);
